
#include <iostream>
//#include "../MissionLab-7.0/src/include/hclient.h"
#include "hclient.h"
#include <unistd.h>

/*
// start
int hclient_open_robot(char *name,bool multipleHservers);
int hclient_range_start(void); // start sonar
// dead reckoning
int hclient_setxyt(float x,float y,float theta); // meters, meters, degrees 
int hclient_getxyt(double *x,double *y,double *t);
// control
int hclient_steer_toward_and_drive(float speed,float theta,float drive_wait_angle = 15.0,int use_reverse = true);
int hclient_stop(void);
// sensors
//int hclient_update_sensors();
int hclient_get_sensor_readings(int mask,int *num,sensor_t **sensorPtr);
// stop
int hclient_range_stop(void); // stop sonar
int hclient_close_robot(void);

typedef struct
{
    int type; // SENSOR_SONAR
    int len_extra;
    char* extra;
    int num_angles;
    float* angle;
    int num_readings;
    float* reading; // (float)SONAR_READING_OUTSIDE_RANGE
} sensor_t;

*/


int main(int argc, char **argv)
{
	int res;
	
	std::cout << "hclient_open_robot... " << std::flush;
	res = hclient_open_robot("fred", false);
	std::cout << res << std::endl;

	std::cout << "hclient_setxyt... " << std::flush;
	res = hclient_setxyt(0, 0, 0);
	std::cout << res << std::endl;

	std::cout << "hclient_init_robot... " << std::flush;
	res = hclient_init_robot(0, 0, 0);
	std::cout << res << std::endl;
	
	std::cout << "hclient_range_start... " << std::flush;
	res = hclient_range_start();
	std::cout << res << std::endl;





	hclient_steer_toward_and_drive(0.75, 0);
	sleep(2);
	hclient_steer_toward_and_drive(0.5,150 );
	sleep(10);
	hclient_steer_toward_and_drive(0.1,260 );
	sleep(18);


	std::cout << "hclient_stop... " << std::flush;
	res = hclient_stop();
	std::cout << res << std::endl;
	
	std::cout << "hclient_range_stop... " << std::flush;
	res = hclient_range_stop(); // stop sonar
	std::cout << res << std::endl;

	std::cout << "hclient_close_robot... " << std::flush;
	res = hclient_close_robot();
	std::cout << res << std::endl;
	
	
	return 0;



}


/*
int main(int argc, char **argv)
{
	int res;
	
	std::cout << "hclient_open_robot... " << std::flush;
	res = hclient_open_robot("fred", false);
	std::cout << res << std::endl;

	std::cout << "hclient_setxyt... " << std::flush;
	res = hclient_setxyt(0, 0, 0);
	std::cout << res << std::endl;

	std::cout << "hclient_init_robot... " << std::flush;
	res = hclient_init_robot(0, 0, 0);
	std::cout << res << std::endl;
	
	std::cout << "hclient_range_start... " << std::flush;
	res = hclient_range_start();
	std::cout << res << std::endl;

	std::cout << "hclient_steer_toward_and_drive... " << std::flush;
	res = hclient_steer_toward_and_drive(0.5, 45);
	std::cout << res << std::endl;

	double x, y, theta;
	for(int i = 0; i < 20; i++)
	{
	
		std::cout << "hclient_get_sensor_readings... " << std::flush;
		int num_sensors;
		sensor_t *sensors;
		res = hclient_get_sensor_readings(0xFFFF, &num_sensors, &sensors);
		std::cout << res << std::endl;
		std::cout << num_sensors << " sensors: ";
		for(int j = 0; j < num_sensors; j++)
		{
			std::cout << "  " << sensors[j].type << " " << sensors[j].len_extra << " (";
			int sensors_extra = sensors[j].len_extra / 12;
			float *pextra = (float*)sensors[j].extra;
			for(int k = 0; k < sensors_extra; k++)
				std::cout << pextra[3*k+0] << "," << pextra[3*k+1] << "," << pextra[3*k+2] << "|";
			std::cout << ") (";
			for(int k = 0; k < sensors[j].num_angles; k++) std::cout << sensors[j].angle[k] << ",";
			std::cout << ") (";
			for(int k = 0; k < sensors[j].num_readings; k++) std::cout << sensors[j].reading[k] << ",";
			std::cout << ")" << std::endl;
		}
		
//		res = hclient_get_obstacles(int mask,float danger_range,sensor_reading_t **reading,bool adjust = false);
		
		
		std::cout << "hclient_getxyt... " << std::flush;
		res = hclient_getxyt(&x, &y, &theta);
		std::cout << res << std::endl;
		std::cout << "state: " << x << ", " << y << ", " << theta << std::endl;
		
	}
		
	std::cout << "hclient_stop... " << std::flush;
	res = hclient_stop();
	std::cout << res << std::endl;
	
	std::cout << "hclient_range_stop... " << std::flush;
	res = hclient_range_stop(); // stop sonar
	std::cout << res << std::endl;

	std::cout << "hclient_close_robot... " << std::flush;
	res = hclient_close_robot();
	std::cout << res << std::endl;
	
	
	return 0;



}

*/
